/***************************************************************************
 *   Copyright 1998,2000  Stephan Kulow <coolo@kde.org>                    *
 *   Copyright 2008 by Davide Bettio <davide.bettio@kdemail.net>           *
 *   Copyright 2009 by Glad Deschrijver <glad.deschrijver@gmail.com>       *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/

#include "lunacalc.h"

#include <QDateTime>

#include "phases.cpp"

LunaCalc::LunaCalc(QObject *parent)
    : QObject(parent)
{
}

QList<QDateTime> LunaCalc::calcStatus(time_t time)
{
	uint lun = 0;
	time_t last_new = 0;
	time_t next_new = 0;
	QList<QDateTime> phases;

	do {
		double JDE = moonphasebylunation(lun, 0);
		last_new = next_new;
		next_new = JDtoDate(JDE, 0);
		lun++;
	} while (next_new < time);

	lun -= 2;

	QDateTime ln;
	ln.setTime_t(last_new);
	phases.append(ln);

	time_t first_quarter = JDtoDate(moonphasebylunation(lun, 1), 0);
	QDateTime fq;
	fq.setTime_t(first_quarter);
	phases.append(fq);

	time_t full_moon = JDtoDate(moonphasebylunation(lun, 2), 0);
	QDateTime fm;
	fm.setTime_t(full_moon);
	phases.append(fm);

	time_t third_quarter = JDtoDate(moonphasebylunation(lun, 3), 0);
	QDateTime tq;
	tq.setTime_t(third_quarter);
	phases.append(tq);

	QDateTime nn;
	nn.setTime_t(next_new);
	phases.append(nn);

	return phases;
}

#include "lunacalc.moc"
