/***************************************************************************
 *   Copyright 2008 by Davide Bettio <davide.bettio@kdemail.net>           *
 *   Copyright 2009 by Glad Deschrijver <glad.deschrijver@gmail.com>       *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/

#ifndef LUNADIALOG_H
#define LUNADIALOG_H

#include <QDateTime>
#include <Plasma/Dialog>

class QLabel;
class QToolButton;
class LunaCalc;

class LunaDialog : public Plasma::Dialog
{
	Q_OBJECT
	public:
		explicit LunaDialog(QWidget *parent = 0, Qt::WindowFlags f = Qt::Window);
		~LunaDialog();

		void setDateTime(QDateTime dateTime);
		void setTodayDateTime(QDateTime dateTime);

	protected slots:
		void updateColors();
		void previousPhases();
		void todayPhases();
		void nextPhases();

	protected:
		virtual void keyPressEvent(QKeyEvent *event);
		virtual void wheelEvent(QWheelEvent *event);

	private:
		void calcStatus(time_t time, bool dateInCurrentMonth = true);

		QLabel *m_lastNewLabel;
		QLabel *m_firstQuarterLabel;
		QLabel *m_fullMoonLabel;
		QLabel *m_thirdQuarterLabel;
		QLabel *m_nextNewLabel;
		QToolButton *m_previousButton;
		QToolButton *m_todayButton;
		QToolButton *m_nextButton;
		LunaCalc *m_lunaCalc;
		QDateTime m_todayDateTime;
		QDateTime m_lastNewDateTime;
		QDateTime m_nextNewDateTime;

		QLabel *m_daysSinceLastNewLabel;
};

#endif
